import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.every.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.some.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.is-array.js";
import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.symbol.iterator.js";
import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.array.from.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.test.js";
import "core-js/modules/es.error.cause.js";
import "core-js/modules/es.error.to-string.js";

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/** Visitor factory for babel, converting React.createElement(...) to <jsx ...>...</jsx>
 *
 * What we want to handle here is this CallExpression:
 *
 *     React.createElement(
 *       type: StringLiteral|Identifier|MemberExpression,
 *       [props: ObjectExpression|Expression],
 *       [...children: StringLiteral|Expression]
 *     )
 *
 * Any of those arguments might also be missing (undefined) and/or invalid. */
export default function (_ref) {
  var t = _ref.types;

  /** Get a JSXElement from a CallExpression
   * Returns null if this impossible */
  function getJSXNode(node) {
    if (!isReactCreateElement(node)) return null; //nameNode and propsNode may be undefined, getJSX* need to handle that

    var _node$arguments = _toArray(node.arguments),
        nameNode = _node$arguments[0],
        propsNode = _node$arguments[1],
        childNodes = _node$arguments.slice(2); // Fragments simply return an array


    if (isReactFragment(nameNode)) {
      return childNodes;
    } // console.log("children", childNodes)


    var name = getJSXName(nameNode);
    if (name === null) return null; //name is required

    var props = getJSXProps(propsNode);
    if (props === null) return null; //no props → [], invalid → null

    var children = getJSXChildren(childNodes);
    if (children === null) return null; //no children → [], invalid → null
    // self-closing tag if no children

    var realChildren = isEmptyChildren(childNodes) ? [] : children;
    var selfClosing = realChildren.length === 0;
    var startTag = t.jSXOpeningElement(name, props, selfClosing);
    var endTag = selfClosing ? null : t.jSXClosingElement(name);
    return t.jSXElement(startTag, endTag, realChildren, selfClosing);
  }
  /** Get a JSXIdentifier or JSXMemberExpression from a Node of known type.
   * Returns null if a unknown node type, null or undefined is passed. */


  function getJSXName(node) {
    if (node == null) return null;
    var name = getJSXIdentifier(node);
    if (name !== null) return name;
    if (!t.isMemberExpression(node)) return null;
    var object = getJSXName(node.object);
    var property = getJSXName(node.property);
    if (object === null || property === null) return null;
    return t.jSXMemberExpression(object, property);
  }
  /** Get a array of JSX(Spread)Attribute from a props ObjectExpression.
   * Handles the _extends Expression babel creates from SpreadElement nodes.
   * Returns null if a validation error occurs. */


  function getJSXProps(node) {
    if (node == null || isNullLikeNode(node)) return [];

    if (t.isCallExpression(node) && t.isIdentifier(node.callee, {
      name: "_extends"
    })) {
      var props = node.arguments.map(getJSXProps); //if calling this recursively works, flatten.

      if (props.every(function (prop) {
        return prop !== null;
      })) return [].concat.apply([], props);
    }

    if (!t.isObjectExpression(node) && t.isExpression(node)) return [t.jSXSpreadAttribute(node)];
    if (!isPlainObjectExpression(node)) return null;
    return node.properties.map(function (prop) {
      return t.isObjectProperty(prop) ? t.jSXAttribute(getJSXIdentifier(prop.key), getJSXAttributeValue(prop.value)) : t.jSXSpreadAttribute(prop.argument);
    });
  }

  function getJSXChild(node) {
    if (t.isStringLiteral(node)) return t.jSXText(node.value);
    if (isReactCreateElement(node)) return getJSXNode(node);
    if (t.isExpression(node)) return t.jSXExpressionContainer(node);
    return null;
  }

  function getJSXChildren(nodes) {
    var children = nodes.filter(function (node) {
      return !isNullLikeNode(node);
    }).map(getJSXChild);
    if (children.some(function (child) {
      return child == null;
    })) return null;
    return children;
  }

  function getJSXIdentifier(node) {
    //TODO: JSXNamespacedName
    if (t.isIdentifier(node)) return t.jSXIdentifier(node.name);
    if (t.isStringLiteral(node)) return t.jSXIdentifier(node.value);
    return null;
  }

  function getJSXAttributeValue(node) {
    if (t.isStringLiteral(node)) return node;
    if (t.isJSXElement(node)) return node;
    if (t.isExpression(node)) return t.jSXExpressionContainer(node);
    return null;
  }
  /** tests if a node is a CallExpression with callee “React.createElement” */


  var isReactCreateElement = function isReactCreateElement(node) {
    return t.isCallExpression(node) && t.isMemberExpression(node.callee) && (t.isIdentifier(node.callee.object, {
      name: "React"
    }) || t.isIdentifier(node.callee.object, {
      name: "ReactDOMRe"
    })) && (t.isIdentifier(node.callee.property, {
      name: "createElement"
    }) || t.isIdentifier(node.callee.property, {
      name: "createDOMElementVariadic"
    })) && !node.callee.computed;
  };

  var isReactFragment = function isReactFragment(node) {
    return t.isMemberExpression(node) && t.isIdentifier(node.object, {
      name: "ReasonReact"
    });
  };

  var isEmptyChildren = function isEmptyChildren(children) {
    return children.every(function (child) {
      return child.elements && child.elements.length === 0;
    });
  };
  /** Tests if a node is “null” or “undefined” */


  var isNullLikeNode = function isNullLikeNode(node) {
    return t.isNullLiteral(node) || t.isIdentifier(node, {
      name: "undefined"
    });
  };
  /** Tests if a node is an object expression with noncomputed, nonmethod attrs */


  var isPlainObjectExpression = function isPlainObjectExpression(node) {
    return t.isObjectExpression(node) && node.properties.every(function (m) {
      return t.isSpreadElement(m) || t.isObjectProperty(m, {
        computed: false
      }) && getJSXIdentifier(m.key) !== null && getJSXAttributeValue(m.value) !== null;
    });
  };

  return {
    visitor: {
      CallExpression: function CallExpression(path) {
        var node = getJSXNode(path.node);
        if (node === null) return null;

        if (node.length && node.length > 0) {
          path.replaceWithMultiple(node);
        } else {
          path.replaceWith(node);
        }
      }
    }
  };
}